/***************************************************************************
 *            radix_sort.c
 *
 *  Sat Dec  8 19:40:42 2007
 *  Copyright  2007  pchero21
 *  pchero21@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include  <limits.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

/******************************************************************************/
/*											 Functions 																			*/

/* radix sort */
int rxsort(int *data, int size, int p, int k);

/* make random array */
void make_RanArray(int max, int significant, int *array);

/* swap each numbers */
void swap(int *a, int *b);

/******************************************************************************/
int main()
{
	int array_size;					// number of index
	int significant_number;		// significant figure number
	int cipher_number;			// cipher number
	int *array;						// index array
	int i;								// tmp number

	printf("Insert array index numbers\n");
	printf("Insert : ");
	scanf("%d", &array_size);

	printf("\n\nInsert cipher numbers\n");
	printf("Insert : ");
	scanf("%d", &cipher_number);

	printf("\n\nInsert significant figure numbers\n");
	printf("Insert : ");
	scanf("%d", &significant_number);

	array = (int *)malloc(array_size * sizeof(int));
	
	make_RanArray(array_size, cipher_number, array);

	printf("\n\nBefore radix_sort\n");
	printf("array : ");
	for(i = 0; i < array_size; i++)
		printf("%d\t", array[i]);
	putchar('\n');
	
	if(rxsort(array, array_size, significant_number, 10) < 0)
		return -1;
	
	printf("\n\nAfter radix_sort\n");
	for(i = 0; i < array_size; i++)
		printf("%d\t", array[i]);
	putchar('\n');
	
	return 0;
}

int rxsort(int *data, int size, int p, int k)
{
	int *counts, *tmp;
	int index, pval, i, j, n;

	/* memory allocate for counts */
	if((counts = (int *)malloc(k * sizeof(int))) == NULL)
		return -1;
	
	/* memory allocate for sort things */
	if((tmp = (int *)malloc(size * sizeof(int))) == NULL)
		return -1;
		
	/* sort from minimum position to maximum position */
	for(n = 0; n < p; n++) {
		/* init counts */
		for(i = 0; i < k; i++)
			counts[i] = 0;
		
		/* calculate location value */
		pval = (int)pow((double)k, (double)n);
		
		/* counting each number hit */
		for(j = 0; j < size; j++) {
			index = (int)(data[j] / pval) % k;
			counts[index] = counts[index] + 1;
		}
		
		/* each count setting for reflection the fore count */
		for(i = 1; i < k; i++)
			counts[i] = counts[i] + counts[i - 1];
		
		/* determine location each item using by counts */
		for(j = size - 1; j >= 0; j--) {
			index = (int)(data[j] / pval) % k;
			tmp[counts[index] - 1] = data[j];
			counts[index] = counts[index] - 1;
		}
		
		/* ready to get the sorted data */
		memcpy(data, tmp, size * sizeof(int));
	}
	
	/* sorting memory release */
	free(counts);
	free(tmp);

	return 0;
}

void make_RanArray(int max, int significant, int *array)
{
	int i, tmp_number;

	for(i = 0; i < max; i++) {
		array[i] = (rand()  % ((int)(pow(10, significant) - 1)));
		if(array[i] < (int)(pow(10, significant - 1)))
			i--;
	}

	tmp_number = max;
	for(i = 0; i < tmp_number; i++)
		swap(&array[rand() % (max - 1)], &array[--tmp_number]);
}

void swap(int *a, int *b)
{
	int tmp;

	tmp = *b;
	*b = *a;
	*a = tmp;
}
